"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Subject {
    constructor() {
        this.subscribes = [];
        this.completes = [];
        this.errors = [];
    }
    complete() {
        const cmplts = this.completes;
        this.completes = [];
        cmplts.forEach(cb => cb());
    }
    next(data) {
        this.subscribes.forEach(cb => cb(data));
    }
    error(data) {
        const errs = this.errors;
        this.errors = [];
        this.completes = [];
        errs.forEach(cb => cb(data));
    }
    subscribe(cb, error, complete) {
        if (cb) {
            this.subscribes.push(cb);
        }
        if (error) {
            this.errors.push(error);
        }
        if (complete) {
            this.completes.push(complete);
        }
    }
}
exports.Subject = Subject;
class Observer extends Subject {
}
exports.Observer = Observer;
class Observable extends Subject {
    static create(observer) {
        const s = new Subject();
        observer(s);
        return s;
    }
}
exports.Observable = Observable;
//# sourceMappingURL=urxjs.js.map