"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const rxjs = require("rxjs");
const urxjs = require("../lib/urxjs");
const rx = require("../lib/abstract-rx");
describe('rx-tests', () => {
    it('subject urxjs', (done) => {
        rx.inject(urxjs);
        const sub = new rx.Subject();
        let completed;
        sub.subscribe((data) => {
            chai_1.assert.equal('simple', data);
            completed = data;
        }, error => {
            chai_1.assert.fail();
        }, () => {
            chai_1.assert.equal('simple', completed);
            done();
        });
        sub.next('simple');
        sub.complete();
    });
    it('subject rxjs', (done) => {
        rx.inject(rxjs);
        const sub = new rx.Subject();
        let completed;
        sub.subscribe((data) => {
            chai_1.assert.equal('simple', data);
            completed = data;
        }, error => {
            chai_1.assert.fail();
        }, () => {
            chai_1.assert.equal('simple', completed);
            done();
        });
        sub.next('simple');
        sub.complete();
    });
});
//# sourceMappingURL=urxjs-test.js.map